unit WalkMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, GPXYGraph, GPXYSeries;

type
  TForm1 = class(TForm)
    GPXYGraph1: TGPXYGraph;
    ButtonRun: TButton;
    ButtonClose: TButton;
    Series1: TXYLineSeries;
    procedure ButtonCloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonRunClick(Sender: TObject);
  private
    { Private 錾 }
    TMax: Integer;
    Done: Boolean;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.ButtonCloseClick(Sender: TObject);
begin
  Done := True;
  Close;
end;

procedure TForm1.ButtonRunClick(Sender: TObject);
var
  T: Integer;
  x, y, theta: Double;
begin
  Series1.Clear;
  Randomize;
  x := 0.0;
	y := 0.0;
  Series1.AddXY(x, y);
  {蓮悤ɂꍇ}
  for T := 0 to TMax do
  begin
    if Done then Break;

  	theta := 2.0 * PI * random;
    x := x + cos(theta);
 		y := y + sin(theta);
    Series1.AddXY(x, y);
    sleep(5);
    GPXYGraph1.Invalidate;
    Application.ProcessMessages;
  end;
(* Cɕ`悷ꍇ
  Series1.BeginUpdate;
  try
    Series1.AddXY(x, y);
    for T := 0 to TMax do
    begin
	  	theta := 2.0 * PI * random;
	    x := x + cos(theta);
  		y := y + sin(theta);
      Series1.AddXY(x, y);
    end;
  finally
    Series1.EndUpdate;
  end;
*)
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  TMax := 400;
  Done := False;
end;

end.
