
unit GPXYGraphEd;


interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Classes, Vcl.Forms,
  DesignIntf, DesignEditors, GPXYSeries, GPXYGraphDlg;

type
  TGPXYGraphEditor = class( TComponentEditor )
    function GetVerbCount : Integer; override;
    function GetVerb( Index : Integer ) : string; override;
    procedure ExecuteVerb( Index : Integer ); override;
  end;

implementation

uses
  GPXYGraph;

function TGPXYGraphEditor.GetVerbCount : Integer;
begin
  Result := 1;
end;

function TGPXYGraphEditor.GetVerb( Index : Integer ) : string;
begin
   Result := 'n̕ҏW';
end;

procedure TGPXYGraphEditor.ExecuteVerb( Index : Integer );
var
  Dialog : TGraphEditDlg;
begin
  Dialog := TGraphEditDlg.Create( Application );
  try
    Dialog.Graph:=(Component as TGPXYGraph);
    Dialog.Caption:=Component.Owner.Name + '.' +Dialog.Graph.Name + ' n̕ҏW';
    Dialog.ShowModal;
  finally
    Dialog.Release;
  end;
  Designer.Modified;
end;

end.
 